Breadth First Search grid shortest path | Graph Theory

Поділитися
Вставка
  • Опубліковано 5 жов 2024

КОМЕНТАРІ • 184

  • @jagrit07
    @jagrit07 4 роки тому +48

    If you are beginner in graph, watch his videos twice or thrice because then you will feel like no one can explain better than him and you will understand each and every point mentioned in the video. Thank you Sir for this playlist.

  • @hamzahfauzy2150
    @hamzahfauzy2150 6 років тому +84

    Finally, i'm waiting for this kind of tutorial
    You're great dude

  • @WilliamFiset-videos
    @WilliamFiset-videos  4 роки тому +72

    A lot of you are asking about how to reconstruct the path, so let me just explain it here.
    To reconstruct the path from the start to the end you need to maintain additional information, namely a 2D matrix which tracks the cell which was used to reach the current cell. Let me call this matrix "prev", short for previous. Every time you advance to the next cell, keep track of which cell you came from in the prev matrix. Once you reach the end of the BFS, start reconstructing the path by beginning at the end node in the prev matrix and work your way to the start node. The obtained path will be in reverse order, so you will need to reverse it.
    This is explained in more detail in the BFS video except that the prev matrix is 1D for the general case: ua-cam.com/video/oDqjPvD54Ss/v-deo.html

    • @austind649
      @austind649 4 роки тому

      Hi William - @14:47, shouldn't we enqueue prior to "continue" on the # equality check? Otherwise certain positions would never be processed.

    • @marjank7781
      @marjank7781 4 роки тому +1

      @@austind649 Hi Austin, whenever we reach a '#' cell, that cell can not be visited as it's an obstacle so can not be in our path. so we don't need to process it and we need to find another path through a reachable cell. The whole point here is only go through the path that is reachable.

    • @ss4036
      @ss4036 4 роки тому +1

      Can you please share the code for saving the actual path along with the moves?

    • @siddharthmagadum16
      @siddharthmagadum16 4 роки тому

      @@ss4036 Here is my code in C++, implemented by the williamfiset approach, which stores the the path and also shows BFS path taken in the matrix.
      pastebin.com/TeMDhspF

    • @Steamed111
      @Steamed111 4 роки тому

      Hi, what about if you can move diagonally? Mine calculates the distance correctly and I had the path reconstruction working for the cardinal directions but once I add diagonal vectors then the path reconstruction works strangely. I know its probably hard to say without looking at my code but how do you modify the above algorithm to account for diagonal? Or should it "just work" if you add the new vectors?

  • @anikethmalyala
    @anikethmalyala 4 роки тому +8

    YOU ARE A LIFE SAVER I COULD NEVER FIND A VIDEO LIKE THIS THANK YOU SO MUCH FOR THE GIFT YOUVE BESTOWED UPON THIS LAND

  • @sarthakshah1058
    @sarthakshah1058 6 років тому +40

    Your videos are amazing, but there is one possible improvement:
    run through the pseudo-code with the animation for the algorithm, so visualizing the pseudo-code becomes easier

    • @adityasingh8973
      @adityasingh8973 4 роки тому +1

      Video for visualization!!
      Watch till end for better visualization.
      Used exactly same concept as explained!!
      ua-cam.com/video/EdJa84ymIXg/v-deo.html

  • @Mnkmnkmnk
    @Mnkmnkmnk 3 роки тому +18

    An alternative to using 'nodes_left_in_layer' and 'nodes_in_next_layer' variables is to store the distance/level along with the coordinates into your queue.
    It does have the downside of using an Object or Array to hold the coordinates and the level, but is easier to understand.

    • @rajns8643
      @rajns8643 10 місяців тому

      Thanks for this approach! Very intuitive indeed!

  • @LunchboxdadioMusic
    @LunchboxdadioMusic 3 роки тому +3

    I rewrote your pseudocode in JavaScript adjusted it a bit to suit my needs. Worked perfectly right out of the box! Awesome work, William!

    • @saiffyros
      @saiffyros Рік тому

      Can you share it?

    • @LunchboxdadioMusic
      @LunchboxdadioMusic Рік тому +1

      @@saiffyros
      // ua-cam.com/video/KiCBXu4P-2Y/v-deo.html
      // Globals
      // number of rows and columns
      const R = 10;
      const C = 14;
      // start cell values
      const sr = 4;
      const sc = 0;
      // row and column queue
      const rq = [];
      const cq = [];
      // save the directions found
      const dir = [];
      // variables to track the steps taken
      let move_count = 0;
      let nodes_left_in_layer = 1;
      let nodes_in_next_layer = 0;
      // variable to check if we've reached the end
      let reached_end = false;
      const map = {
      cols: 14,
      rows: 10,
      sSize: 64,
      tsize: 40
      }
      const gameGrid = [
      [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0],
      [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0],
      [ 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0],
      [ 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 0],
      [ 8, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0],
      [ 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0],
      [ 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 0],
      [ 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0],
      [ 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0],
      [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
      ]
      // R x C matrix of false values aka visited positions
      const visited = [
      [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
      [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
      [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
      [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
      [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
      [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
      [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
      [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
      [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
      [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
      ]
      // north, south, east, west direction vectors
      const dr = [ -1, +1, 0, 0];
      const dc = [ 0, 0, +1, -1];
      function findPath(){
      rq.push(sr);
      cq.push(sc);
      visited[sr][sc] = true;
      // Keep going as long as there are items in the queue
      while(rq.length > 0 || cq.length > 0){
      let r = rq.shift();
      let c = cq.shift();
      if(gameGrid[r][c] === 'E'){
      reached_end = true;
      break;
      }
      check_neighbors( r, c)
      nodes_left_in_layer --;
      if(nodes_left_in_layer === 0){
      nodes_left_in_layer = nodes_in_next_layer;
      nodes_in_next_layer = 0;
      move_count ++;
      }
      }
      if(reached_end){
      return move_count;
      }
      return -1;
      }
      function check_neighbors( r, c){
      for(let i = 0; i < 4; i++){
      let rr = r + dr[i];
      let cc = c + dc[i];
      //skip out of bounds cells
      if(rr < 0 || cc < 0){
      continue;
      }
      if(rr >= R || cc >= C){
      continue;
      }
      // skip blocked or visited cells
      if(visited[rr][cc]){
      continue;
      }
      if(gameGrid[rr][cc] === 0){
      continue;
      }
      let move = [dc[i], dr[i]];
      dir.push(move);
      rq.push(rr);
      cq.push(cc);
      visited[rr][cc] = true;
      nodes_in_next_layer ++;
      }
      }
      findPath();
      function getTile(c, r){
      return gameGrid[r][c];
      }
      export { dir, map, getTile };

  • @shivamsahni6720
    @shivamsahni6720 4 роки тому +3

    William your explanation and animation creates a clear picture in my head about the underlying Concept, Thanks alot man!

  • @brunokawka
    @brunokawka 4 роки тому +2

    This is probably one of the most helpful 'Algorithms & Data Structures' channels I've yet encountered. The idea of maintaining multiple queues for each dimension is really handy.

    • @alikhansmt
      @alikhansmt 4 роки тому +1

      Can you please explain why its better to have separate queues for each dimension? I cant see how its better than having one queue with the dimensions encapsulated into one object..

    • @brunokawka
      @brunokawka 4 роки тому +2

      @@alikhansmt It's just a personal preference of mine. I've found this approach quicker to implement, and reuse over larger code structures, where I don't like to maintain a vast amount of structs, dot callbacks etc... Speaking in terms of competitive programming of course.

    • @alikhansmt
      @alikhansmt 4 роки тому

      @@brunokawka I see thanks!

  • @JinkProject
    @JinkProject 5 років тому +2

    i love how slow you speak and how thoroughly you explain everything. thanks!

  • @create_space812
    @create_space812 3 роки тому +2

    Thank you William for the great video. Fellow Canadian here. thank you for the high-quality content!

  • @JustMe111094
    @JustMe111094 4 роки тому +17

    This channel is a gem. very high quality content in these tutorial videos!

  • @rohitkumar-rq6qh
    @rohitkumar-rq6qh 6 років тому +10

    This is nice.I have seen this trick used by competitive programmers for traversing in the grid.

  • @dj1984x
    @dj1984x Рік тому

    excellent explanation. I particularly liked your concept for using direction vectors

  • @harishshankar682
    @harishshankar682 4 роки тому +2

    Best explanation for coding problems and approaches!! Thanks for making such high quality content on UA-cam

  • @hemanthchalla4833
    @hemanthchalla4833 5 років тому +2

    I was hammering about how to solve these ki9nd of problems. You are a savior! Please make these kind of tutorials more. I cannot thank you enough. Subscribed!

  • @andrewstien7179
    @andrewstien7179 3 роки тому +4

    What a great tutorial! A great explanation complemented by incredibly clear slides and animations. Thanks.

  • @Toasterparty
    @Toasterparty 4 роки тому

    My mind is blown at how many things can be modeled as a graph. I go out into the world and just see graphs now.

  • @huseyinbarin1653
    @huseyinbarin1653 2 роки тому +2

    Very clear approach! Just would like to share something regarding using 2 queues for 2D Matrixes, it just affects the performance very badly single Queue implementation is much more efficient. Other than this, great explanation thanks.

    • @rajns8643
      @rajns8643 10 місяців тому +1

      Efficient in terms of memory complexity, right?
      (Because handling so many queues in n-dimensional space would require a lot of memory I presume).

  • @tc07client5
    @tc07client5 6 років тому +2

    I am preparing for IOI and this video was very Helpful, continue to make great contents like this. Thanks!

  • @zinda__bad
    @zinda__bad 3 місяці тому

    Brilliant video, thank you so much for these.
    I think you could also modify solve() to return a prev collection as in the BFS Shortest Path video, and add the end cell coordinates or marker character ('E') as a parameter to the enclosing function. Then you no longer need all the global counting variables (nodes_left_in_layer etc). You would need to perform [number of steps in shortes path] iterations over prev to get the shortest path and return shortest_path.size() - 1.
    Maybe not optimal since you have to iterate over the shortest path too, but as long as you still break inside solve() when reached_end = True, the time complexity should stay the same.

  • @Sumit-sl5lp
    @Sumit-sl5lp 5 років тому +3

    this is exactly what i needed to know to solve graph problems, thanks for the video :) watching your tutorial for the first time, should have watched it earlier.

  • @gayanhewa
    @gayanhewa 5 років тому +1

    Good stuff, for my dumb brain it wasn't clear in the first glance why we needed the nodes_in_next_layer and nodes_left_in_layer and how it's used. Had to replay and follow through the algorithm to understand its use.

    • @eurekagao2078
      @eurekagao2078 5 років тому +12

      Try to think this way: BFS is visiting graph layer by layer. Initially the nodes_left_in_layer = 1; supposed that there're 2 adjacent nodes (A, B)connecting the starting node(S), so the nodes_in_next_layer will be incremented to 2 after the explorer_neighbours(), then the nodes_left_in_layer is decremented to 0. Here, we reset the nodes_left_in_layer to 2 and nodes_in_next_layer to 0 and increment the move_count to 1. It means after visiting layer 1, we are expecting to visit 2 nodes in layer 2. We can image node A has 3 adjacent nodes (C, D, E) and node B has 1 adjacent nodes (F). Now try to go-thru layer 2 with the imaginary graph - we visit A, nodes_in_next_layer is set to 3, nodes_left_in_layer is set to 1, then visit B, nodes_in_next_layer is set to 4 and nodes_left_in_layer to 0. Here, we are finishing visit layer 2 and expecting to visit layer 3 with 4 coming nodes.
      snap shots of queue:
      (S)
      (A) (B) // nodes_in_next_layer = 2, after visiting layer 1;
      (B) (C) (D) (E) // pop (A) and push all neighbours (C) (D) (E)
      (C) (D) (E) (F) // pop (B) and push neighbour (E)
      // nodes_in_next_layer = 4, after visiting layer 2;
      Hope this helps.

    • @jsarvesh
      @jsarvesh 3 роки тому +3

      i think level would be better name compared to layer as BFS processes nodes which are at same level/distance from current node. Once we process all the nodes in current level, we move onto the next level. BFS is also called commonly referred to as level order traversal

    • @hil449
      @hil449 2 роки тому +1

      @@jsarvesh yea, level is a much better name. I also find easier to code and understand passing an additional information into the object/struct of the queue, that is the level so when i push neighbors to the queue i increment this level/distance like this:
      q.push((position){.level=nextLevel, .row=nextRow, .col=nextCol, .distance=pos.distance + 1});

  • @adambruce4284
    @adambruce4284 2 роки тому +1

    This is some of the best fucking content I've ever seen. Absolutely fucking incredible. 10/10 would peek again!

  • @vaibhavlodha5398
    @vaibhavlodha5398 5 років тому +2

    Great video. thank you very much. This is exactly what I needed to understand how to solve graph problem using adjacency matrix. Thank you once again!

  • @josephwong2832
    @josephwong2832 4 роки тому +2

    Thanks a lot Will! This is from cracking the coding interview and your walkthrough is well explained. I'm subbing to your channel now

  • @Hajjat
    @Hajjat 5 років тому +3

    Amazing explanation, thanks for the video! I've been always avoiding BFS and going with DFS since I wasn't comfortable with it, but not anymore! Subscribed to your channel... Will be waiting for more tutorials from you!

  • @aguluman
    @aguluman 5 місяців тому

    A fellow student from hyperskill, psted your video link. On the lee algorithm course conent.
    It is helpful.

  • @user-or7ji5hv8y
    @user-or7ji5hv8y 5 років тому

    really like the summary in the end, as well. it's a nice touch.

  • @chingizmardanov
    @chingizmardanov 5 років тому +1

    You are just brilliant man! I hope your channel grows big!

  • @dmitriy5763
    @dmitriy5763 3 роки тому +1

    Thank you so much! You definitely have talent in explaining!

  • @ego_sum_liberi
    @ego_sum_liberi 6 років тому +5

    Bravo! you are one of a kind, keep rocking!!!

  • @hagergamal2856
    @hagergamal2856 3 роки тому +1

    This is amazing ♥️
    Please keep solving that kind of problems ♥️♥️😍

  • @srv7151
    @srv7151 4 роки тому

    Best video on 2d Grid Thank You for the explanation

  • @senthilkumar5
    @senthilkumar5 5 років тому +1

    Thank you so much for simplifying it

  • @germin1983
    @germin1983 2 роки тому +1

    Now that I know the shortest path in value. How do i highlight the path it took.

  • @Nealpa
    @Nealpa Рік тому

    Such a great explanation!!

  • @nurlan1666
    @nurlan1666 2 роки тому +1

    Спасибо вам, за хорошее объяснение

  • @anikethmalyala
    @anikethmalyala 4 роки тому

    This helped me so much you don't even know TYSM

  • @Garentei
    @Garentei 4 роки тому +1

    Thanks for the multiple queue trick. Storing them as pairs does not scale well to higher dimensions and p.first and p.second looks really ugly and ambiguous.

  • @samtux762
    @samtux762 5 років тому

    I also use two int arrays instead of an array of int,int objects. Before I was shy to tell about it because it is "not OOP". Now my design is backed by this video.

  • @mukulbakshi28
    @mukulbakshi28 4 роки тому

    Man, wish I could see this before. Encountered this same problem in my First Round of Google Interview For Software Engineer.

    • @kickhuggy
      @kickhuggy 4 роки тому

      Dude, their on site is all day variations of BFS problems, there's no hope lol

    • @hil449
      @hil449 2 роки тому

      @@kickhuggy really? thats actually pretty cool lol

  • @codeblooded6760
    @codeblooded6760 4 роки тому +5

    I didnt understand how r u calculating nodes left in layer and nodes in next layer

  • @ayoubed3496
    @ayoubed3496 5 років тому +15

    Your videos are amazing, really!
    Can I know where do you run your animations, please?

  • @ZzBiazZ
    @ZzBiazZ 11 місяців тому

    Awesome video, thank you so much!

  • @andreamengoli4656
    @andreamengoli4656 4 роки тому +1

    Thank you.. this is helpful for making games as well

  • @TheMato1112
    @TheMato1112 4 роки тому

    Thank you very much. It helped me a lot.

  • @grandson_f_phixis9480
    @grandson_f_phixis9480 4 місяці тому

    Thank you very much sir!!

  • @mohdfayaq3037
    @mohdfayaq3037 5 років тому

    Great buddy! Got it in the first go!

  • @brayaon
    @brayaon 4 роки тому

    thank you so much for these videos!

  • @sairamankilambi5007
    @sairamankilambi5007 4 роки тому

    Quality content. Really appreciate it👍

  • @dudeov
    @dudeov 3 роки тому

    Amazing video! Thanks a ton!

  • @vanyastaleva415
    @vanyastaleva415 5 років тому

    Am I the only one who missed the part where we select the path that he colored in green? What's explained in this video only shows how many steps we need to reach the end, but not the actual path.

  • @InfinityFnatic
    @InfinityFnatic 5 років тому +1

    Amazing tutorial! Keep filming please :)

  • @juliesz78
    @juliesz78 3 роки тому

    Awesome video!!! Thanks bro!

  • @kompeterPC
    @kompeterPC 4 роки тому

    Good explanation, thanks a lot

  • @catalinadascalete7094
    @catalinadascalete7094 5 років тому

    Great tutorial! Congrats

  • @LawZist
    @LawZist 6 років тому +3

    keep with the good job!

  • @sumant9120
    @sumant9120 4 роки тому +1

    Could anyone explain what is the use of 'nodes_left_in_layer' and 'nodes_in_next_layer' variables?

  • @prakhardoshi6525
    @prakhardoshi6525 5 років тому +1

    Brilliant ! Thank you :)

  • @adityamaurya3673
    @adityamaurya3673 2 роки тому +1

    what happen if we are allowed to go in 8 direction diagonal also included then i think only BFS will not work anybody??

  • @tejasri2564
    @tejasri2564 3 роки тому +2

    what is the time complexity for this?

  • @orocimarosay1447
    @orocimarosay1447 3 роки тому +1

    But it is better to keep everything in one queue due to cache efficiency and you could just use a struct Point{int x; int y;};

  • @sonluuh
    @sonluuh 3 роки тому

    Hi, I have a (maybe so stupid question). BFS cannot use as a shortest path finding with weighted graph right? (it just work with unweight - or all the edge have the same priority). I am not sure about this because at the video Overview, you said it can be use as shortest path finding algorithms. (But to my knowlege, it is impossible). Maybe i got mistake, thanks.

  • @a2pha
    @a2pha 2 роки тому

    8:36 I understand the "Fill" method to get all the tiles, yet how are you getting this path from that ?

  • @icecreamicequeen28
    @icecreamicequeen28 4 роки тому

    THANK YOU!

  • @urbantech28
    @urbantech28 4 роки тому +1

    Used queue and showing Stack ... :(

  • @muhammadsaifuddinjazulijaz3898
    @muhammadsaifuddinjazulijaz3898 4 роки тому

    Your videos are amazing, but how do I get the short path if reached end ?, because my move_count data has already been calculated

  • @sasanktadepalli1231
    @sasanktadepalli1231 4 роки тому

    Sir, one doubt.
    At first u said about using Adjacency List/Matrix.
    Later u worked directly on the grid.
    How to do it using Adjacency List/Matrix???

    • @WilliamFiset-videos
      @WilliamFiset-videos  4 роки тому

      You can use a regular BFS with an adjacency list (or matrix), see ua-cam.com/video/oDqjPvD54Ss/v-deo.html.

    • @sasanktadepalli1231
      @sasanktadepalli1231 4 роки тому

      Ok, thank you sir

  • @shivakumar-gr4go
    @shivakumar-gr4go 6 років тому

    Looking at the order of direction vectors which is (-1,0), (+1,0), (0,+1), (0, -1)...it looks like you are interested to move row wise first and then column wise. Then how does it become breadth first algorithm. As BFA says, we to move across the row first right.

    • @WilliamFiset-videos
      @WilliamFiset-videos  6 років тому +1

      Hi Shiva, it doesn't matter which direction vector is applied first because you're doing the BFS layer by layer and adding newly discovered nodes to the end of the queue.

    • @shivakumar-gr4go
      @shivakumar-gr4go 6 років тому

      That's exactly is my question.. how does this approach taking breadth first. With the use of vectors we go on finding the next node to traverse and looking at the these vectors, traversing need not be breadth wise. Because you are looking for next node above and below the current node first. I hope it makes sense.

    • @WilliamFiset-videos
      @WilliamFiset-videos  6 років тому +2

      Let me try and make this as clear as possible. For any given node, we add all the neighbors of that node to the list of nodes that need to be visited (unless the neighboring node has already been visited, is not traversable or something weird). The list of nodes to be visited is stored in a queue data structure. The queue has the property that the most recent node added to the queue is found at the end and the oldest node which has been in the queue the longest at the beginning. This means that we can add nodes to the queue and know that they will eventually get processed at a later stage. When the BFS starts you add the starting node to the queue to indicate that it should be visited. The algorithm begins by dequeuing (removing) the start node from the beginning of the queue, after which you add the left, right, down and up neighbors of the start node to the queue in that order (which shouldn't matter). Then the starting node's left node is first in the queue, so you add its left, right, down and up neighbors to the queue, then the starting node's right node if first in the queue, so you add its left, right, down and up neighbors to the queue, and etc... So the algorithm circles around if you will and the graph is explored layer by layer

    • @shivakumar-gr4go
      @shivakumar-gr4go 6 років тому

      Thanks for the detailed explanation ....

  • @goestriyadi
    @goestriyadi Рік тому

    I created a ArrayList variable to store the steps taken, but it store all the block the BFS explored instead of the green block that shown in the video.
    How can I only store the shortest block need to be explored only?

  • @AsliArtistVlogs
    @AsliArtistVlogs 3 роки тому

    What do you mean by a 'layer'? (I am sorry if I missed it but I think its missing from the video)

  • @rmp251
    @rmp251 2 роки тому

    8:55 how do we find the number of steps without tracing the path itself?

  • @Sumit-sl5lp
    @Sumit-sl5lp 5 років тому

    Hi William, shouldn't the move count be move_count+1(if reached_end is true) as we are breaking the loop and not incrementing move_count for the last layer(where end node was found)?

    • @prokiddie3520
      @prokiddie3520 5 років тому

      No. When reaching the layer containing the E, the step to get to that layer is already accounted for.

  • @anonymoussloth6687
    @anonymoussloth6687 3 роки тому

    for the dungeon problem, why do we have to use bfs? why not dfs?

  • @kolick7547
    @kolick7547 3 роки тому

    How is it possible to get returned the coords for the path? I dont think the queue in the end contains the path or my implementation is wrong.

  • @tilakramyadav559
    @tilakramyadav559 4 роки тому

    Thanks a lot

  • @journeytowardslife9830
    @journeytowardslife9830 3 роки тому

    How do we know that this algorithm gives the shortest path ?

  • @PGWalkthrough
    @PGWalkthrough 5 років тому

    thanks very useful video can someone please tell me how i can solve a maze that does not have walls (boundaries) which means a maze that allows wrapping

  • @priyanshuraturi8808
    @priyanshuraturi8808 4 роки тому

    what if we are allowed to take off one obstacle???

  • @geraldbustos
    @geraldbustos 3 роки тому

    Notable

  • @ziadhossam5862
    @ziadhossam5862 2 роки тому

    I was wondering how I can solve the same problem using DFS (bearing in mind I want to get any path not the shortest one)

    • @WilliamFiset-videos
      @WilliamFiset-videos  2 роки тому

      You can using backtracking, however I wouldn't recommend it since it'll be quite slow. If you need a faster shortest path algorithm have a look at my Dijkstra video

  • @chamathtoo
    @chamathtoo 5 місяців тому

    thanks it s really great bt how can I get the source code for this?

  • @alouminotavros
    @alouminotavros 4 роки тому

    thanks a lot.

  • @ujjwalrawat5105
    @ujjwalrawat5105 2 роки тому

    I don't understand the nodes left in layer and nodes in next layer part. Can someone link to a C++ solution to this problem using STL?

  • @tempregex8520
    @tempregex8520 3 роки тому

    can someone please help me understand, why is it we choose BFS over DFS to find "shortest path" ? i believe it has to be the way BFS traverses a graph as compared to DFS, but looking for a better explanation

  • @PavLosMavRis
    @PavLosMavRis 3 роки тому

    What about the Robot Vacuum Cleaner problem, a double array 3x3 a robot is somewhere in the grid and in some cells there is dirt and the robot must find the optimal path in order to clean the cells and doing that with the BFS algorithm. Any suggestions?

  • @kartikeyasrivastava987
    @kartikeyasrivastava987 4 роки тому

    Are you the same guy from freecodecamp video?

  • @dennissmith3216
    @dennissmith3216 5 років тому

    Something is missing from this solution: The shortest path. The function returns the shortest number of steps, but how do I find the actual path?

    • @WilliamFiset-videos
      @WilliamFiset-videos  5 років тому +1

      You will need additional information to do that. Maintain a 2D matrix which tracks the cell from which you came for every cell. Once you reach the end of the BFS, start reconstructing the path by beginning at the end node and work your way to the start node. The obtained path will be in reverse order, so you will need to reverse it.

    • @WilliamFiset-videos
      @WilliamFiset-videos  5 років тому

      I go over this in my previous video for general graphs: ua-cam.com/video/oDqjPvD54Ss/v-deo.html

  • @iitianx4373
    @iitianx4373 3 роки тому

    thanks a lot

  • @cheebye8019
    @cheebye8019 4 роки тому

    11:16 does this pseudo code applies for a 3d grid graph? im confused you mention to use 3 queues for 3ds grid graph and then went straight back to 2d pseudo code

  • @AnkitSharma-gf6ok
    @AnkitSharma-gf6ok 4 роки тому

    thanks ,,, that was helpfull

  • @muzafferckay2609
    @muzafferckay2609 4 роки тому

    You are the best

  • @zahraahoosen1718
    @zahraahoosen1718 4 роки тому +2

    I think Kelvin Jose plagiarised your video in his article on graph theory:
    towardsdatascience.com/graph-theory-bfs-shortest-path-problem-on-a-grid-1437d5cb4023
    Think it's extremely unfair he didn't credit you at all...

    • @WilliamFiset-videos
      @WilliamFiset-videos  4 роки тому +2

      Thanks for reporting. Nearly all his posts seem to be exact copies of my content :/

    • @zahraahoosen1718
      @zahraahoosen1718 4 роки тому

      @@WilliamFiset-videos I think you could try report him for a copyright violation or something like that. Hopefully that website understands the issue and removes his articles because stealing content ain't cool at all. :(

  • @LunaMarlowe327
    @LunaMarlowe327 5 років тому

    This guy is insane

  • @_va3y
    @_va3y 2 роки тому

    is there a related leetcode problem to practice?

  • @saadahmad485
    @saadahmad485 3 роки тому

    Damn this was good

  • @huyvuquang2041
    @huyvuquang2041 4 роки тому

    Big like for you. Thanks a lot :))

  • @luqmanahmad3153
    @luqmanahmad3153 5 років тому

    can you explain why we use BFS algorithm? why you did not solve it by DFS or any other?

    • @WilliamFiset-videos
      @WilliamFiset-videos  5 років тому +1

      I could have solved this using DFS, but the BFS has the advantage that it'll find the shortest path because all edges are unweighted

    • @luqmanahmad3153
      @luqmanahmad3153 5 років тому

      @@WilliamFiset-videos but what if the cost of moving left, right and diagonal cell cost us. then which algo you will prefer?

    • @WilliamFiset-videos
      @WilliamFiset-videos  5 років тому

      @@luqmanahmad3153 Dijkstras algorithm. I also have a video on it.

    • @luqmanahmad3153
      @luqmanahmad3153 5 років тому

      What about uniform cost search? It will find cheapest path

  • @ganeshkumar-ye4zq
    @ganeshkumar-ye4zq 3 роки тому

    the dungeon is now in 3-D!